{
  self,
  flake-utils,
  nixpkgs,
  agenix,
  devshell,
  treefmt-nix,
  ...
}@inputs:
(flake-utils.lib.eachDefaultSystem (
  system:
  let
    pkgs = nixpkgs.legacyPackages.${system};
    treefmtEval = treefmt-nix.lib.evalModule pkgs ./treefmt.nix;
  in
  {
    devShells.default =
      let
        pkgs = import nixpkgs {
          inherit system;
          overlays = [
            agenix.overlays.default
            devshell.overlays.default
          ];
        };
        extraModules = [ "${devshell}/extra/git/hooks.nix" ];
      in
      import ./devshell.nix { inherit pkgs extraModules; };

    formatter = treefmtEval.config.build.wrapper;

    packages = import ./pkgs { inherit pkgs; } // {
      installer-iso = inputs.self.nixosConfigurations.installer.config.system.build.isoImage;
    };
  }
))
// {
  checks = import ./checks.nix inputs;
  hmModules = import ./home/modules.nix { lib = nixpkgs.lib; };
  hmConfigurations = {
    dadada = import ./home;
  };
  nixosConfigurations = import ./nixos/configurations.nix inputs;
  nixosModules = import ./nixos/modules { lib = nixpkgs.lib; };
}
